"use strict";
/*
 * Deepkit Framework
 * Copyright (C) 2021 Deepkit UG, Marc J. Schmidt
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the MIT License.
 *
 * You should have received a copy of the MIT License along with this program.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.sqliteSerializer = void 0;
const sql_1 = require("@deepkit/sql");
const type_1 = require("@deepkit/type");
class SQLiteSerializer extends sql_1.SqlSerializer {
    constructor() {
        super(...arguments);
        this.name = 'sqlite';
    }
    registerSerializers() {
        super.registerSerializers();
        this.serializeRegistry.registerClass(Date, (type, state) => {
            state.addSetter(`${state.accessor}.toJSON();`);
        });
        this.serializeRegistry.append(type_1.ReflectionKind.boolean, (type, state) => {
            if (!(0, sql_1.isDirectPropertyOfEntity)(type))
                return;
            state.addSetter(`${state.accessor} ? 1 : 0`);
        });
    }
}
exports.sqliteSerializer = new SQLiteSerializer;
//# sourceMappingURL=sqlite-serializer.js.map